static const char version[] = "$Id: logging_event.c,v 1.4 2002/11/20 15:38:34 legoater Exp $";

/*
 * logging_event.c
 *
 * Copyright 2001-2002, Meiosys SA (www.meiosys.com). All rights reserved.
 * Copyright 2001-2002, Cedric Le Goater <legoater@meiosys.com>. All rights reserved.
 *
 * See the COPYING file for the terms of usage and distribution.
 */

#include <log4c/logging_event.h>
#include <log4c/category.h>
#include <stdlib.h>
#include <sd/malloc.h>

/*******************************************************************************/
extern log4c_logging_event_t* log4c_logging_event_new(
    const char* a_category,
    int		a_priority,
    const char*	a_message)
{
    log4c_logging_event_t* evt;

    evt 		= sd_calloc(1, sizeof(log4c_logging_event_t));    
    evt->evt_category	= a_category;
    evt->evt_priority	= a_priority;
    evt->evt_msg	= a_message;

    gettimeofday(&evt->evt_timestamp, NULL);

    return evt;
}

/*******************************************************************************/
extern void log4c_logging_event_delete(log4c_logging_event_t* this)
{
    if (!this)
	return;

    free(this);
}

